freeslot(
"sfx_walk",
"sfx_run"
)


addHook("AbilitySpecial", function(player)
    if player.mo and player.mo.skin == "sonic"
	and player.pflags & PF_THOKKED 
	P_SpawnSkidDust(player, -4*FRACUNIT, sfx_none)
	P_SetObjectMomZ(player.mo, -27*FRACUNIT, true)
		S_StartSound(player.mo, sfx_thok, player)
		P_SpawnGhostMobj(player.mo)
		P_InstaThrust(player.mo, player.mo.angle, 47*FRACUNIT)
	end
end)


addHook("PlayerThink", function(player)
	if player.mo and player.mo.skin == "tails" and (player.cmd.buttons & BT_CUSTOM1)
	    if player.mo.state == S_PLAY_FLY or player.mo.state == S_PLAY_FLY_TIRED or player.mo.state == S_PLAY_SWIM
		   S_StartSound(player.mo, sfx_spin, player)
           player.pflags = $1|PF_THOKKED|PF_JUMPED
		   P_SpawnThokMobj(player)
		   player.mo.state = S_PLAY_ROLL
		end
	end
end)


addHook("PlayerThink", function(player)
	if player.mo and player.mo.skin == "knuckles" and (player.cmd.buttons & BT_SPIN)
	    if player.mo.state == S_PLAY_GLIDE
		   S_StartSound(player.mo, sfx_spin, player)
           player.pflags = $1|PF_THOKKED|PF_JUMPED
		   player.pflags = $ & ~PF_GLIDING
		   P_SpawnThokMobj(player)
		   player.mo.state = S_PLAY_ROLL
		end
	end
end)


addHook("PlayerThink", function(player)
	for player in players.iterate
	     if (player.mo.state == S_PLAY_JUMP)
	         P_SpawnThokMobj(player)
		end
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
	     if (player.mo.state == S_PLAY_JUMP)
	         P_SpawnThokMobj(player)
		end
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
	     if (player.mo.state == S_PLAY_WALK) and (player.mo.frame == C) and P_IsObjectOnGround(player.mo)
	         S_StartSound(player.mo, sfx_walk, player)
		end
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
	     if (player.mo.state == S_PLAY_WALK) and (player.mo.frame == G) and P_IsObjectOnGround(player.mo)
	         S_StartSound(player.mo, sfx_walk, player)
		end
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
	if (player.mo.state == S_PLAY_RUN) and not player.powers[pw_super] and (player.mo.frame == B) and P_IsObjectOnGround(player.mo)
        player.normalspeed = 46*FRACUNIT
		P_SpawnSkidDust(player, -7*FRACUNIT, sfx_none)
		S_StartSound(player.mo, sfx_run, player)
		P_IsObjectOnGround(player.mo)
		end
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
	     if (player.mo.state == S_PLAY_RUN) and (player.mo.frame == G)
		end
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
	if (player.mo.state == S_PLAY_DASH) and not player.powers[pw_super] and P_IsObjectOnGround(player.mo) then
	    player.powers[pw_invulnerability] = TICRATE/4
        player.normalspeed = 58*FRACUNIT
		P_SpawnSkidDust(player, -9*FRACUNIT, sfx_none)
		S_StartSound(player.mo, sfx_run, player)
		P_SpawnGhostMobj(player.mo)
		end
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
	     if (player.mo.state == S_PLAY_DASH) and (player.mo.frame == A) and P_IsObjectOnGround(player.mo)
		end
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
	     if (player.mo.state == S_PLAY_DASH) and (player.mo.frame == C)
		end
	end
end)


addHook("PlayerThink", function(player)
	if player.mo and player.mo.skin == "sonic" and (player.cmd.buttons & BT_CUSTOM1) and player.powers[pw_super]
		if player.mo.state == S_PLAY_JUMP
		   P_NukeEnemies(player.mo, player.mo, 3000*FRACUNIT)
		   P_FlashPal(player, PAL_NUKE, 8)
		   player.mo.state = S_PLAY_SUPER_TRANS1
		   S_StartSound(player.mo, sfx_bkpoof, player)
		end
	end
end)


addHook("PlayerThink", function(player)
	if player.mo and player.mo.skin == "knuckles" and (player.cmd.buttons & BT_CUSTOM1) and player.powers[pw_super]
		if player.mo.state == S_PLAY_JUMP
		   P_NukeEnemies(player.mo, player.mo, 3000*FRACUNIT)
		   P_FlashPal(player, PAL_NUKE, 8)
		   player.mo.state = S_PLAY_SUPER_TRANS1
		   S_StartSound(player.mo, sfx_bkpoof, player)
		end
	end
end)


addHook("PlayerThink", function(player)
	if player.mo and player.mo.skin == "metalsonic" and (player.cmd.buttons & BT_CUSTOM1) and player.powers[pw_super]
		if player.mo.state == S_PLAY_JUMP
		   P_NukeEnemies(player.mo, player.mo, 3000*FRACUNIT)
		   P_FlashPal(player, PAL_NUKE, 8)
		   player.mo.state = S_PLAY_SUPER_TRANS1
		   S_StartSound(player.mo, sfx_bkpoof, player)
		end
	end
end)
